/*

Pattern Memory Game; James Bensley; GNU GPLv3 Distribution; Feedback Appriciated;

Dont ask me for help if you can't get it working becuase I don't know what I'm doing...true story!

*/

// Headers
#include "Pitches.h"  // library for the note to tone generation tables
#include "LiquidCrystal.h"  // library for the liquid crystal display on a 4bit bus (I think!)

// Global Constants
// Analog Pins:
const int intPinPotent = 2;  // the pin location of our potentiometer
// Digital Pins
const int intPinSpeaker = 6;  // the pin location of our speaker
const int intPinButton = 7;  // the pin location of our button
const int intPinLED =  8;  // the pin number of the LED
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);  // set the pin numbers for the 4bit LCD bus stuff

const int intPatternCount = 4;  // constant declaring how many patterns will be played
// (rember this is one more the for zero, 0, value)

// Global Variables:
int bolButtonState = 0;  // variable for reading the pushbutton status
int intPotent = 0;  // variable for storing the value of the potentiometer resistance

int aryPattern[intPatternCount];  // array for storing the current games pattern
int intPatternIndex = 0;  // integer for storing the current position in the pattern array
int aryAnswer[intPatternCount];  // array for storing the users answers
int intAnswerIndex = 0;  // integer for storing the current position in the answer array

int intGameState = 0;  // inital game state, 0 is "click to begin"

// Sound Setup
int aryDeathNotes[] = {NOTE_G3, NOTE_G3, NOTE_G3, NOTE_DS3, 0, NOTE_AS3, NOTE_G3, NOTE_DS3, 0, NOTE_AS3, NOTE_G3};
int aryDeathDuration[] = {2, 2, 2, 4, 8, 8, 2, 4, 8, 8, 1}; // note durations: 4 = quarter note, 8 = eighth note, etc

int aryWinnerNotes[] = {
NOTE_A4, NOTE_B4, NOTE_C4, NOTE_D4, NOTE_E4, NOTE_F4, NOTE_G4, 
NOTE_A4, NOTE_B4, NOTE_C4, NOTE_D4, NOTE_E4, NOTE_F4, NOTE_G4,
NOTE_A4, NOTE_B4, NOTE_C4, NOTE_D4, NOTE_E4, NOTE_F4, NOTE_G4
};

void setup()  //Pre loop setup sub
{

  // set up our board pins appropriately as inputs or outputs
  pinMode(intPinButton, INPUT); // the button is going to be an input signal source 
  // as we wish to read its state to see weather is has been pushed
  pinMode(intPinLED, OUTPUT); // the LED pin is going to be an output signal destination
  // as we wish to use it for debugging
  
  lcd.begin(16,2);  // set up the screen, we have a screen that is 16 cols by 2 rows
  lcd.setCursor(0,0);  // set the cursor for the first line of the menu
  lcd.print("Memory Game");  // print the first line of the menu
  lcd.setCursor(0,1);  // set the cursor for the second line of the menu
  lcd.print("Click To Begin");  // print the second line of the menu
  playDeathMarch();  // greet the user, audiably
  
}

void loop()  // Main chip loop
{
  
  // read the state of the push button value:
  bolButtonState = digitalRead(intPinButton);
  // check if the pushbutton is pressed.
  // if it is, the buttonState will be HIGH:
  if (bolButtonState == HIGH) {
    // turn LED on:
    digitalWrite(intPinLED, HIGH);
  } 
  else {
    // turn LED off:
    digitalWrite(intPinLED, LOW); 
  }
  
  switch(intGameState)  // the current game state dictates what 
  // options are given to the user on the screen
  {
    case 0:  // waiting to start the current round
      if(bolButtonState==HIGH)  // when the button is pushed the round starts
      {
        aryPattern[intPatternIndex] = random(102);  // generate a random number
        displayPattern();  // flash our generated pattern at the user
      }
    break;
    
    case 1:  // user input mode
      lcd.setCursor(0,0);  // set the cursor for user prompt
      lcd.print("Input Answer");  // prompt the user they must select the answer
      lcd.setCursor(0,1);  // set the cursor for displaying the users choice
      intPotent = analogRead(intPinPotent)/10;
      lcd.print(intPotent);
      if(analogRead(intPinPotent)/10 != intPotent)  // if the potentiometer has been change...
      {
        intPotent = analogRead(intPinPotent)/10;  // grab the new value
        lcd.print("               ");  // blank off the rest of the screen
        lcd.print(intPotent);  // update the screen with the new value
        lcd.print("               ");  // blank off the rest of the screen
      }
      
      if(bolButtonState==HIGH)  // if the button has been pressed, the user is happy with their selection
      {
        answerPattern();  // call the submit answer sub
      }
    break;
    
    case 2:  // the end of round screen
      lcd.setCursor(0,0);  // set up cursor for congratulatory prompt
      lcd.print("Great Job!");  // let them think they are good at something
      lcd.setCursor(0,1);  // set up cursor position for options
      lcd.print("Press & Progress");  // let the user now they have the option to go to the next round
      if(bolButtonState==HIGH)  // if the button has been pressed, we shall go on to the next round
      {
        intPatternIndex++;  // increment the pattern index
        if(intPatternIndex<intPatternCount)  // check if this was the last round of the game
        {
          // if it wasn't...
          intAnswerIndex = 0;  // reset the answer index
          intGameState = 0;  // start the next round
        }
        else
        {  // if the user has made it to the end they are the grand winner!
          intGameState = 4;  // go to the screen of champions!
        }
        delay(100); //Debug delay? ################
      }
      break;
    
    case 3:  // the loser screen, time to start over!
      lcd.setCursor(0,0);
      lcd.print("     LOSER      ");
      lcd.setCursor(0,1);
      lcd.print(" Press to retry ");
      if(bolButtonState==HIGH)  // if the button has been pressed, we shall restart
      {
          intAnswerIndex = 0;  // reset the answer index
          intGameState = 0;  // start the next round
      }
    break;
    
    case 4:  // the winner screen, time to celebrate!
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print(" You 'da' Man!  ");
      delay(500);
      lcd.clear();
      lcd.print("Press to restart");
      delay(500);
      if(bolButtonState==HIGH)  // if the button has been pressed, we shall restart the whole game
      {
        intAnswerIndex = 0;  // reset the answer index
        intGameState = 0;  // start the next round
        intPatternIndex = 0;  // restart the round counter/pattern index
        delay(200); //Debug delay? ################
        setup();
      }
    break;
    
  }
  
}

void displayPattern()  // This sub loops through each array item 
// and displays it one at a time for a brief period,
// before whiping he screen and displaying the next
{
  
 lcd.clear();  // Clear what ever was on the screen
 for(int x=0;x<=intPatternIndex;x++)  // loop round the number of patterns in our array
 {
   lcd.print(aryPattern[x]);  // print the current array index value
   delay(500);  // wait half a second...
   lcd.clear();  // then clear the screen
 }
 intGameState = 1;  // move the game state on to the user input interfacy bity
 
}

void answerPattern()
{
  
  lcd.clear();
  aryAnswer[intAnswerIndex] = intPotent;  // add the current potentiometer value to the answers array
  delay(500); //Debug delay? ################
  
  if(intPotent != aryPattern[intAnswerIndex])
  {
    intGameState = 3;  // the user has got an answer wrong, go to the loser screen
    delay(200); //Debug delay? ################
    return;
  }
  
  if(intAnswerIndex==intPatternIndex)  // if we have submitted the same amount of answers
  // as there were numbers to remember, we must be done answering!
  {
    for(int x=0;x<=intPatternIndex;x++)  // loop round the number of patterns in play
    {
      if(aryPattern[x] != aryAnswer[x])  // check that each pattern is the same as each answer provided
      {
        intGameState = 3;  // if the user hasn't passed all answer checks
        delay(200); //Debug delay? ################
        // a mistake was made and so the user has lost, goto losing screen
        return;
      }
    }
    // if the code drops to here the user has passed each answer as so can progress on wards
    // to the next round
    intGameState = 2;  // go to the intermidiary game start which lets the player know
    delay(200); //Debug delay? ################
    playWinner();  // any time the user wins a round, congratulate then audiably
    return;
  }
  // if the code drops to here we have more answers to give
  intAnswerIndex++;  // so increment the answer index
  intGameState = 1; // and take more user input by going back to game state 1
  delay(200); //Debug delay? ################
  lcd.print("Next");
  delay(500);
  lcd.clear();
}

void playWinner()
{
 // Loop through the notes in the winners theme tune
  for (int x=0; x<21;x++) {
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int intDuration = 1000/32;
    tone(intPinSpeaker, aryWinnerNotes[x], intDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int intDelay = intDuration * 1.30;
    delay(intDelay);
  } 
}

void playDeathMarch()
{
 // Loop through the notes in the Imperial Death March! Mwuhahaha!
  for (int x=0; x<11;x++) {
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int intDuration = 1000/aryDeathDuration[x];
    tone(intPinSpeaker, aryDeathNotes[x], intDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int intDelay = intDuration * 1.30;
    delay(intDelay);
  } 
}
